package ru.landgrafhomyak.db.skeleton1.api.table

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.skeleton1.api.ReflectionApi
import ru.landgrafhomyak.db.skeleton1.api.module.Module
import ru.landgrafhomyak.db.skeleton1.api.module.ModuleScopedObject

public interface Table<UE : Any, mUE : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("uExt")
	public val uExt: UE

	public val unwrappedTable: Table<UE, mUE>

	@ReflectionApi
	public val pathFromParentModuleRoot: List<String>?

	@ReflectionApi
	public val parentModule: Module<mUE>

	public enum class LifeTime {
		DATABASE_SCOPE,
		TRANSACTION_SCOPE,
		CONNECTION_SCOPE,
		MODULE_UPGRADE_SCOPE
	}

	@ReflectionApi
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getLifeTime")
	public val lifeTime: LifeTime

	@ReflectionApi
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getMemberColumns")
	public val memberColumns: Collection<Column<*, UE>>

	@ReflectionApi
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getMemberObjects")
	public val memberObjects: Collection<TableScopedObject<UE>>

	@ReflectionApi
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getMemberColumnsWhileUpgrade")
	public val memberColumnsWhileUpgrade: Collection<Column<*, UE>>

	@ReflectionApi
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("getMemberObjectsWhileUpgrade")
	public val memberObjectsWhileUpgrade: Collection<TableScopedObject<UE>>

	public interface Constructor<tUE : Any> {
		public fun createTable(context: TableConstructorScope<tUE>): tUE
	}

	public interface Upgrade<tnUE : Any, toUE : Any> {
		public fun upgradeTable(oldTable: toUE, context: TableUpgradeScope<tnUE, toUE>): tnUE
	}
}